/** \mainpage Driver Overview
  *
  * \section section_drv_info Driver Information
  * This Sensor Controller Interface driver has been generated by the Texas Instruments Sensor Controller
  * Studio tool:
  * - <b>Project name</b>:     HCACapTouchIRLED
  * - <b>Project file</b>:     C:/Users/a0132640/Desktop/HCACapTouch_IRLED_7bits.scp
  * - <b>Code prefix</b>:      -
  * - <b>Operating system</b>: TI-RTOS
  * - <b>Tool version</b>:     1.3.0.42428
  * - <b>Tool patches</b>:     None
  * - <b>Target chip</b>:      CC1310, revision -, package QFN48 7x7 RGZ
  * - <b>Created</b>:          2016-10-21 11:13:07.154
  * - <b>Computer</b>:         LTOSSTD02
  * - <b>User</b>:             a0132640
  *
  * No user-provided resource definitions were used to generate this driver.
  *
  * No user-provided procedure definitions were used to generate this driver.
  *
  * Do not edit the generated source code files other than temporarily for debug purposes. Any
  * modifications will be overwritten by the Sensor Controller Studio when generating new output.
  *
  * \section section_drv_modules Driver Modules
  * The driver is divided into three modules:
  * - \ref module_scif_generic_interface, providing the API for:
  *     - Initializing and uninitializing the driver
  *     - Task control (for starting, stopping and executing Sensor Controller tasks)
  *     - Task data exchange (for producing input data to and consume output data from Sensor Controller
  *       tasks)
  * - \ref module_scif_driver_setup, containing:
  *     - The AUX RAM image (i.e. Sensor Controller code and data)
  *     - I/O mapping information
  *     - Task data structure information
  *     - Driver setup data, to be used in the driver initialization
  *     - Project-specific functionality
  * - \ref module_scif_osal, for flexible OS support:
  *     - Interfaces with the selected operating system
  *
  * It is possible to use output from multiple Sensor Controller Studio projects in one application. Only
  * one driver setup may be active at a time, but it is possible to switch between these setups. When
  * using this option, there is one instance of the \ref module_scif_generic_interface and
  * \ref module_scif_osal modules, and multiple instances of the \ref module_scif_driver_setup module.
  * This requires that:
  * - The outputs must be generated using the same version of Sensor Controller Studio
  * - The outputs must use the same operating system
  * - The outputs must use different source code prefixes (inserted into all globals of the
  *   \ref module_scif_driver_setup)
  *
  *
  * \section section_project_info Project Description
  * No description entered
  *
  *
  * \subsection section_io_mapping I/O Mapping
  * Task I/O functions are mapped to the following pins:
  * - CapTouchButton:
  *     - <b>AXD: CapTouch Button area on TIDA00848 0</b>: DIO30
  * - LMT70:
  *     - <b>A: Input from LMT70 Sensor 1</b>: DIO23
  *     - <b>A: Input from LMT70 Sensor 2</b>: DIO25
  *     - <b>O: Enable Power Supply pin for Sensor 1 2</b>: DIO24
  * - TRXIRLED:
  *     - <b>AXS: LED Cathode Reverse BIAS</b>: DIO28
  *     - <b>O: Transmit pin to LED Anode</b>: DIO29
  *
  *
  * \section section_task_info Task Description(s)
  * This driver supports the following task(s):
  *
  *
  * \subsection section_task_desc_cap_touch_button CapTouchButton
  * Samples the Cap Touch PCB element on TIDA-00848 (CC1310 HCA 1-chip)
  * 
  * The TDC data (i.e. the time taken to charge up each capacitive area from 0 to 0.8 V) are output to
  * the System CPU. This includes raw data.
  * 
  * 
  * \subsection section_task_desc_lmt70 LMT70
  * Sampling of two LMT70A analog temp. sensors
  * 
  * 
  * \subsection section_task_desc_trxirled TRXIRLED
  * No description entered
  *
  */




/** \addtogroup module_scif_driver_setup Driver Setup
  *
  * \section section_driver_setup_overview Overview
  *
  * This driver setup instance has been generated for:
  * - <b>Project name</b>:     HCACapTouchIRLED
  * - <b>Code prefix</b>:      -
  *
  * The driver setup module contains the generated output from the Sensor Controller Studio project:
  * - Location of task control and scheduling data structures in AUX RAM
  * - The AUX RAM image, and the size the image
  * - Task data structure information (location, size and buffer count)
  * - I/O pin mapping translation table
  * - Task resource initialization and uninitialization functions
  *
  * @{
  */
#ifndef SCIF_H
#define SCIF_H

#include <stdint.h>
#include <stdbool.h>
#include "scif_framework.h"
#include "scif_osal_tirtos.h"


/// Target chip name
#define SCIF_TARGET_CHIP_NAME_CC1310
/// Target chip package
#define SCIF_TARGET_CHIP_PACKAGE_QFN48_7X7_RGZ

/// Number of tasks implemented by this driver
#define SCIF_TASK_COUNT 3

/// CapTouchButton: Task ID
#define SCIF_CAP_TOUCH_BUTTON_TASK_ID 0
/// LMT70: Task ID
#define SCIF_LMT70_TASK_ID 1
/// TRXIRLED: Task ID
#define SCIF_TRXIRLED_TASK_ID 2


/// CapTouchButton: Number of PCB Touch buttons
#define SCIF_CAP_TOUCH_BUTTON_PIN_COUNT 1
/// CapTouchButton I/O mapping: CapTouch Button area on TIDA00848
#define SCIF_CAP_TOUCH_BUTTON_DIO_AXD_PCB_BUTTON { 30 }
/// LMT70 I/O mapping: Input from LMT70 Sensor 1
#define SCIF_LMT70_DIO_A_LMT1_AIN 23
/// LMT70 I/O mapping: Input from LMT70 Sensor 2
#define SCIF_LMT70_DIO_A_LMT2_AIN 25
/// LMT70 I/O mapping: Enable Power Supply pin for Sensor 1 2
#define SCIF_LMT70_DIO_O_LMT_ON 24
/// TRXIRLED: periodic
#define SCIF_TRXIRLED_TIMER_MODE_PERIODICAL 1
/// TRXIRLED: Buffer size for IR bits
#define SCIF_TRXIRLED_ARRAY_SIZE 100
/// TRXIRLED I/O mapping: LED Cathode Reverse BIAS
#define SCIF_TRXIRLED_DIO_AXS_IR_ENB 28
/// TRXIRLED I/O mapping: Transmit pin to LED Anode
#define SCIF_TRXIRLED_DIO_O_LEDTX 29


// All shared data structures in AUX RAM need to be packed
#pragma pack(push, 2)


/// CapTouchButton: Task configuration structure
typedef struct {
    uint16_t pAuxioAxdPcbButton[1]; ///< I/O mapping: CapTouch Button area on TIDA00848
} SCIF_CAP_TOUCH_BUTTON_CFG_T;


/// CapTouchButton: Task output data structure
typedef struct {
    uint16_t baselineValue; ///< 
    uint16_t pTdcValueFilt; ///< TDC value, filtered
    uint16_t pTdcValueRaw;  ///< TDC Value, raw
} SCIF_CAP_TOUCH_BUTTON_OUTPUT_T;


/// CapTouchButton: Task state structure
typedef struct {
    uint16_t filtInitDone;    ///< Has the value filtering been initialized?
    uint16_t patternDetected; ///< PCB Touch Event flag
    uint16_t threshold;       ///< Variable
} SCIF_CAP_TOUCH_BUTTON_STATE_T;


/// LMT70: Task output data structure
typedef struct {
    uint16_t adcVal1; ///< Readout of first LMT70A
    uint16_t adcVal2; ///< Readout of second LMT70A 
} SCIF_LMT70_OUTPUT_T;


/// TRXIRLED: Task input data structure
typedef struct {
    uint16_t address; ///< TX data for LED
    uint16_t enable;  ///< IR LED operation mode: (TX=1) or RX=0
} SCIF_TRXIRLED_INPUT_T;


/// TRXIRLED: Task output data structure
typedef struct {
    uint16_t irSIG[100]; ///< Stores the IrDA Bits (incl. Start and Stop Bit)
} SCIF_TRXIRLED_OUTPUT_T;


/// TRXIRLED: Task state structure
typedef struct {
    uint16_t irlightDetected; ///< Detect IR pulse
} SCIF_TRXIRLED_STATE_T;


/// Sensor Controller task data (configuration, input buffer(s), output buffer(s) and internal state)
typedef struct {
    struct {
        SCIF_CAP_TOUCH_BUTTON_CFG_T cfg;
        SCIF_CAP_TOUCH_BUTTON_OUTPUT_T output;
        SCIF_CAP_TOUCH_BUTTON_STATE_T state;
    } capTouchButton;
    struct {
        SCIF_LMT70_OUTPUT_T output;
    } lmt70;
    struct {
        SCIF_TRXIRLED_INPUT_T input;
        SCIF_TRXIRLED_OUTPUT_T output;
        SCIF_TRXIRLED_STATE_T state;
    } trxirled;
} SCIF_TASK_DATA_T;

/// Sensor Controller task generic control (located in AUX RAM)
#define scifTaskData    (*((volatile SCIF_TASK_DATA_T*) 0x400E00F6))


// Initialized internal driver data, to be used in the call to \ref scifInit()
extern const SCIF_DATA_T scifDriverSetup;


// Restore previous struct packing setting
#pragma pack(pop)


// AUX I/O re-initialization functions
void scifReinitTaskIo(uint32_t bvTaskIds);


// RTC-based tick generation control
void scifStartRtcTicks(uint32_t tickStart, uint32_t tickPeriod);
void scifStartRtcTicksNow(uint32_t tickPeriod);
void scifStopRtcTicks(void);


#endif
//@}


// Generated by LTOSSTD02 at 2016-10-21 11:13:07.154
